# -*- coding: utf-8 -*-
# Daum Movie

import urllib, unicodedata, json

#DAUM_MOVIE_SRCH   = "http://movie.daum.net/search.do?type=%s&q=%s"
#DAUM_MOVIE_SRCH   = "http://m.movie.daum.net/search/main?searchType=%s&searchText=%s&page=1&sortType=acc"
#DAUM_MOVIE_SRCH   = "http://m.movie.daum.net/data/movie/search/v2/%s.json?size=20&searchText=%s&start=1&sortType=acc"
DAUM_MOVIE_SRCH   = "http://movie.daum.net/data/movie/search/v2/%s.json?size=20&searchText=%s&start=1&sortType=acc"

JSON_MOVIE_DETAIL = "http://m.movie.daum.net/data/movie/movie_info/detail.json?movieId=%s"
DAUM_MOVIE_DETAIL = "http://m.movie.daum.net/moviedb/main?movieId=%s"
JSON_MOVIE_CAST   = "http://m.movie.daum.net/data/movie/movie_info/cast_crew.json?pageNo=1&pageSize=100&movieId=%s"
DAUM_MOVIE_CAST   = "http://m.movie.daum.net/moviedb/crew?movieId=%s"
DAUM_MOVIE_PHOTO  = "http://m.movie.daum.net/data/movie/photo/movie/list.json?pageNo=1&pageSize=100&id=%s"

JSON_TV_DETAIL    = "http://m.movie.daum.net/tv/main.json?tvProgramId=%s"
DAUM_TV_DETAIL    = "http://m.movie.daum.net/tv/main?tvProgramId=%s"
DAUM_TV_DETAIL2   = "http://movie.daum.net/tv/detail/main.do?tvProgramId=%s"
JSON_TV_CAST      = "http://m.movie.daum.net/data/movie/tv/cast_crew.json?pageNo=1&pageSize=100&tvProgramId=%s"
DAUM_TV_CAST      = "http://m.movie.daum.net/tv/crew?tvProgramId=%s"
DAUM_TV_PHOTO     = "http://m.movie.daum.net/data/movie/photo/tv/list.json?pageNo=1&pageSize=100&id=%s"
#DAUM_TV_EPISODE   = "http://m.movie.daum.net/m/tv/episode?tvProgramId=%s"
DAUM_TV_EPISODE   = "http://m.movie.daum.net/tv/episode?tvProgramId=%s"

IMDB_TITLE_SRCH   = "http://www.google.com/search?q=site:imdb.com+%s"
TVDB_TITLE_SRCH   = "http://thetvdb.com/api/GetSeries.php?seriesname=%s"

RE_YEAR_IN_NAME   =  Regex('\((\d+)\)')
RE_MOVIE_ID       =  Regex("movieId=(\d+)")
RE_TV_ID          =  Regex("tvProgramId=(\d+)")
RE_PHOTO_SIZE     =  Regex("/C\d+x\d+/")
RE_IMDB_ID        =  Regex("/(tt\d+)/")
RE_DURATION       =  Regex('(\d+)분')

def Start():
  HTTP.CacheTime = CACHE_1WEEK
  HTTP.Headers['Accept'] = 'text/html, application/json'

####################################################################################################
def searchDaumMovie(cate, results, media, lang):
  media_name = media.show if cate == 'tv' else media.name
  media_name = unicodedata.normalize('NFKC', unicode(media_name)).strip()
  media_year = 0 if media.year == None else media.year
  Log.Debug("search: %s %s" %(media_name, media_year))

  #url = DAUM_MOVIE_SRCH % (cate, urllib.quote(media_name.encode('utf8')))
  #url = DAUM_MOVIE_SRCH % (cate, urllib.quote(media_name))
  url = DAUM_MOVIE_SRCH % (cate, media_name.replace(" ", "%20"))

  #html = HTML.ElementFromURL( url )

  #items = html.xpath('//span[@class="fl srch"]')
  #for item in items:
  #  try: year = RE_YEAR_IN_NAME.search(HTML.StringFromElement(item)).group(1)
  #  except: year = None
  #  node= item.xpath('a')[0]
  #  title = "".join(node.xpath('descendant-or-self::text()'))
  #  url = node.get('href')
  #  id_ptn = RE_TV_ID if cate == 'tv' else RE_MOVIE_ID
  #  id = id_ptn.search(url).group(1)

  #  if year == media.year:
  #    score = 95
  #  elif len(items) == 1:
  #    score = 80
  #  else:
  #    score = 10
    
  #params = urllib.urlencode({'page': 1, 'musicianId': -1})
  #r = urllib.urlopen(url, params).read()
  #data = json.loads(r)
  data = JSON.ObjectFromURL(url)
  jdata = data["data"]
  for i, item in enumerate(jdata):
    #year = item.get("prodYear")
    year = item['prodYear']
    #title = ""+item.get("titleKo")
    title = ""+item['titleKo']
    #title = re.sub('<[^>]*>', '', title)
    title = String.StripTags(title)
    #id = item.get("movieId")
    id = item['tvProgramId'] if cate == 'tv' else item['movieId']
      
    if int(year) == int(media_year):
      score = 95
    elif data['count'] == 1:
      score = 80
    else:
      score = 10
        
    Log.Debug('ID=%s, media_name=%s, title=%s, year=%s, y2=%s, score=%s, lang=%s' %(id, media_name, title, year, media_year, score, lang))
    results.Append(MetadataSearchResult(id=str(id), name=title, year=str(year), score=score, lang=lang))
    
  #results.Append(MetadataSearchResult(id='999', name='test', year='2016', score='90', lang=lang))
  Log.Debug('Found = ' + str(len(results)))

def updateDaumMovie(cate, metadata):
  # (1) from detail page
  url_tmpl = DAUM_TV_DETAIL if cate == 'tv' else DAUM_MOVIE_DETAIL
  url = url_tmpl % metadata.id
  html = HTML.ElementFromURL( url )

  metadata.title = html.xpath('//h2[@class="tit_rel"]/a')[0].text
  #metadata.original_title = info['titleEn']
  metadata.genres.clear()
  if cate == 'tv':
    #try: metadata.rating = float(info['tvProgramPoint']['pointAvg'])
    #except: pass
    #metadata.genres.add(info['categoryHigh']['codeName'])
    for genre in html.xpath("//dt[text()='"+u"장르"+"']/following-sibling::dd")[0].text.split('/'):
      metadata.genres.add(genre.strip())
    #metadata.studio = info['channel']['titleKo'] if info['channel'] else ''
    metadata.duration = 0
    #try: metadata.originally_available_at = Datetime.ParseDate(info['startDate']).date()
    try: metadata.originally_available_at = Datetime.ParseDate(html.xpath("//dt[text()='"+u"현재"+"']/following-sibling::dd")[0].text.split('~')[0]).date()
    except: pass
    #Log.Debug('Year = %s' %(html.xpath("//dt[text()='"+u"현재"+"']/following-sibling::dd")[0].text.split('~')[0]))
    #metadata.summary = String.DecodeHTMLEntities(String.StripTags(info['introduce']).strip())
    metadata.summary = String.DecodeHTMLEntities('\n'.join(html.xpath('//p[@class="desc_movie"]//text()')))
  else:
    item = html.xpath('//strong[@class="tit_movie"]')
    #try: metadata.year = RE_YEAR_IN_NAME.search(HTML.StringFromElement(item[0])).group(1)
    try: metadata.year = int(RE_YEAR_IN_NAME.search(item[0].text).group(1))
    except: metadata.year = None
    #Log.Debug('Year = %s' %(item[0].text)) 
    
    for genre in html.xpath("//dt[text()='"+u"장르"+"']/following-sibling::dd")[0].text.split('/'):
      metadata.genres.add(genre.strip())

    try:
      item = html.xpath("//dt[text()='"+u"영화시간/타입"+"']/following-sibling::dd")[0].text
      metadata.duration = int(RE_YEAR_IN_NAME.search(item).group(1))
    except: pass
    
    try: metadata.originally_available_at = Datetime.ParseDate(html.xpath("//dt[text()='"+u"개봉"+"']/following-sibling::dd")[0].text.split('|')[0]).date()
    except: pass
        
    #metadata.summary = String.DecodeHTMLEntities(String.StripTags(html.xpath('//p[@class="desc_movie"]')[0].text).strip())
    try: metadata.summary = String.DecodeHTMLEntities('\n'.join(html.xpath('//div[@class="desc_movie"]/p//text()')))
    except: pass

    metadata.countries.clear()
    
    try:
      for country in html.xpath("//dt[text()='"+u"나라"+"']/following-sibling::dd")[0].text.split(','):
        metadata.countries.add(country.strip())
    except: pass

  try: metadata.rating = float(html.xpath('//em[@class="emph_grade"]')[0].text)
  except: pass    

  try: poster_url = html.xpath('//span[contains(@class, "thumb_summary")]/img')[0].get('src')
  except: poster_url = ''
  Log.Debug('poster = ' + poster_url)
    #poster = HTTP.Request( poster_url )
    #metadata.posters[poster_url] = Proxy.Media(poster)

  # (2) cast crew
  directors = list()
  writers = list()
  metadata.roles.clear()
  metadata.directors.clear()
  metadata.writers.clear()
  url_tmpl = DAUM_TV_CAST if cate == 'tv' else DAUM_MOVIE_CAST
  url = url_tmpl % metadata.id
  html = HTML.ElementFromURL( url )

  items = html.xpath('//div[contains(@class, "movie_join")]/div/h4[text()="'+u"감독"+'"]/parent::div/parent::div')
  for item in items:
    #staffs = item.xpath('//em[@class="emph_point"]')
    staffs = item.xpath('ul/li/a/span/strong/em')
    for staff in staffs:
      if len(staff.text.strip()) == 0: continue
      #directors.append(staff.text)
      
      try:
        meta_director = metadata.directors.new()
        meta_director.name = staff.text.strip()
      except:
        try:
          metadata.directors.add(staff.text.strip())
        except:
          pass
      

  items = html.xpath('//div[contains(@class, "movie_join")]/div/h4[text()="'+u"주연"+'"]/parent::div/parent::div')
  for item in items:
    #staffs = item.xpath('//em[@class="emph_point"]')
    staffs = item.xpath('ul/li/a/span/strong/em')
    for staff in staffs:
      if len(staff.text.strip()) == 0: continue
      role = metadata.roles.new()
      #role.role = u"주연"
      try: 
        role.role = staff.xpath('../../span/span')[0].text
      except: pass

      try:
        role.name = staff.text      
      except:
        try:
          role.actor = staff.text
        except:
          pass
      #metadata.roles.add(role)

  #Log.Debug('Here !!! ')
  
  items = html.xpath('//div[contains(@class, "movie_join")]/div/h4[text()="'+u"출연"+'"]/parent::div/parent::div')
  for item in items:
    #staffs = item.xpath('//em[@class="emph_point"]')
    staffs = item.xpath('ul/li/a/span/strong/em')
    for staff in staffs:
      if staff.text.strip() == '': continue
      role = metadata.roles.new()
      #role.role = u"출연"
      try: 
        role.role = staff.xpath('../../span/span')[0].text
      except: pass

      try:
        role.name = staff.text      
      except:
        try:
          role.actor = staff.text
        except:
          pass
      #metadata.roles.add(role)
      #Log.Debug('Role added = ' + staff.xpath('../../span/span')[0].text)
	      
  for item in html.xpath('//dt[text()="'+u"각본"+'"]/following-sibling::dd'):
    for staff in item.xpath('span/a'):
      if len(staff.text.strip()) == 0: continue
      #writers.append(staff.text)
      try:
        meta_writer = metadata.writers.new()
        meta_writer.name = staff.text.strip()
      except:
        try:
          metadata.writers.add(staff.text.strip())
        except:
          pass

  if len(directors) == 0:
    items = html.xpath('//span[text()="'+u"연출"+'"]/parent::span')
    for item in items:
      #staffs = item.xpath('//em[@class="emph_point"]')
      staffs = item.xpath('strong/em')
      for staff in staffs:
        if len(staff.text.strip()) == 0: continue
        try:
          meta_director = metadata.directors.new()
          meta_director.name = staff.text.strip()
        except:
          try:
            metadata.directors.add(staff.text.strip())
          except:
            pass
        
        #directors.append(staff.text)
        #Log.Debug('Director added = ' + staff.text)

  if len(writers) == 0:
    items = html.xpath('//span[text()="'+u"극본"+'"]/parent::span')
    for item in items:
      #staffs = item.xpath('//em[@class="emph_point"]')
      staffs = item.xpath('strong/em')
      for staff in staffs:
        if len(staff.text.strip()) == 0: continue
        try:
          meta_writer = metadata.writers.new()
          meta_writer.name = staff.text.strip()
        except:
          try:
            metadata.writers.add(staff.text.strip())
          except:
            pass
        #writers.append(staff.text)
        #Log.Debug('Director added = ' + staff.text)

  #if cate == 'movie':
  #  metadata.directors.clear()
  #  metadata.writers.clear()
  #  for name in directors:
  #    metadata.directors.add(name)
  #  for name in writers:
  #    metadata.writers.add(name)

  # (3) from photo page
  url_tmpl = DAUM_TV_PHOTO if cate == 'tv' else DAUM_MOVIE_PHOTO
  data = JSON.ObjectFromURL(url=url_tmpl % metadata.id)
  max_poster = int(Prefs['max_num_posters'])
  max_art = int(Prefs['max_num_arts'])
  idx_poster = 0
  idx_art = 0
  for item in data['data']:
    if item['photoCategory'] == '1' and idx_poster < max_poster:
      art_url = item['fullname']
      if not art_url: continue
      #art_url = RE_PHOTO_SIZE.sub("/image/", art_url)
      art = HTTP.Request( item['thumbnail'] )
      idx_poster += 1
      metadata.posters[art_url] = Proxy.Preview(art, sort_order = idx_poster)
    elif item['photoCategory'] in ['2', '50'] and idx_art < max_art:
      art_url = item['fullname']
      if not art_url: continue
      #art_url = RE_PHOTO_SIZE.sub("/image/", art_url)
      art = HTTP.Request( item['thumbnail'] )
      idx_art += 1
      metadata.art[art_url] = Proxy.Preview(art, sort_order = idx_art)
  Log.Debug('Total %d posters, %d artworks' %(idx_poster, idx_art))
  if idx_poster == 0:
    if poster_url:
      poster = HTTP.Request( poster_url )
      metadata.posters[poster_url] = Proxy.Media(poster)
    else:
      url = 'http://m.movie.daum.net/m/tv/main?tvProgramId=%s' % metadata.id
      html = HTML.ElementFromURL( url )
      arts = html.xpath('//img[@class="thumb_program"]')
      for art in arts:
        art_url = art.attrib['src']
        if not art_url: continue
        art = HTTP.Request( art_url )
        idx_poster += 1
        metadata.posters[art_url] = Proxy.Preview(art, sort_order = idx_poster)
	
  if cate == 'tv':
    # (4) from episode page
    page = HTTP.Request(DAUM_TV_EPISODE % metadata.id).content
    #match = Regex('MoreView\.init\(\d+, (.*), \$\(', Regex.DOTALL).search(page)
    match = Regex('MoreView\.init\(\d+, (.*)\);.{1,5}MoreView\.setPageCount', Regex.DOTALL).search(page)
    #match = Regex('MoreView\.init\(\d+, (.*)\)\;.*?MoreView\.setPage', Regex.DOTALL).findall(page)
    #if len(match) > 0:
    if match:
      data = JSON.ObjectFromString(match.group(1))
      #data = JSON.ObjectFromString(match[0][0])
      Log.Debug('Total %d episodes' %(len(data)))
      for item in data:
        episode_num = item['sequence']
        episode = metadata.seasons['1'].episodes[episode_num]
        episode.title = item['title']
        episode.summary = item['introduceDescription'].strip()
        if item['channels'][0]['broadcastDate']:
          episode.originally_available_at = Datetime.ParseDate(item['channels'][0]['broadcastDate'], '%Y%m%d').date()
        try: episode.rating = float(item['rate'])
        except: pass
        episode.directors.clear()
        episode.writers.clear()
        for name in directors:
          episode.directors.add(name)
        for name in writers:
          episode.writers.add(name)
        #episode.thumbs[thumb_url] = Proxy.Preview(thumb_data)

    # (5) fill missing info
    if Prefs['override_tv_id'] != 'None':
      page = HTTP.Request(DAUM_TV_DETAIL2 % metadata.id).content
      match = Regex('<em class="title_AKA"> *<span class="eng">([^<]*)</span>').search(page)
      if match:
        metadata.original_title = match.group(1).strip()


def updateDaumMovie_Old(cate, metadata):
  # (1) from detail page
  url_tmpl = JSON_TV_DETAIL if cate == 'tv' else JSON_MOVIE_DETAIL
  data = JSON.ObjectFromURL(url=url_tmpl % metadata.id)
  info = data['data']
  metadata.title = info['titleKo']
  metadata.original_title = info['titleEn']
  metadata.genres.clear()
  if cate == 'tv':
    try: metadata.rating = float(info['tvProgramPoint']['pointAvg'])
    except: pass
    metadata.genres.add(info['categoryHigh']['codeName'])
    metadata.studio = info['channel']['titleKo'] if info['channel'] else ''
    metadata.duration = 0
    try: metadata.originally_available_at = Datetime.ParseDate(info['startDate']).date()
    except: pass
    metadata.summary = String.DecodeHTMLEntities(String.StripTags(info['introduce']).strip())
  else:
    metadata.year = int(info['prodYear'])
    try: metadata.rating = float(info['moviePoint']['inspectPointAvg'])
    except: pass
    for item in info['genres']:
      metadata.genres.add(item['genreName'])
    try: metadata.duration = int(info['showtime'])*60
    except: pass
    try: metadata.originally_available_at = Datetime.ParseDate(info['releaseDate']).date()
    except: pass
    metadata.summary = String.DecodeHTMLEntities(String.StripTags(info['plot']).strip())

    metadata.countries.clear()
    for item in info['countries']:
      metadata.countries.add(item['countryKo'])

  poster_url = info['photo']['fullname']

  # (2) cast crew
  directors = list()
  writers = list()
  metadata.roles.clear()
  url_tmpl = DAUM_TV_CAST if cate == 'tv' else DAUM_MOVIE_CAST
  data = JSON.ObjectFromURL(url=url_tmpl % metadata.id)
  for item in data['data']:
    cast = item['castcrew']
    if cast['castcrewCastName'] == [u'감독', u'연출']:
      directors.append(item['nameKo'] if item['nameKo'] else item['nameEn'])
    elif cast['castcrewCastName'] == u'극본':
      writers.append(item['nameKo'] if item['nameKo'] else item['nameEn'])
    elif cast['castcrewCastName'] in [u'주연', u'조연', u'출현', u'진행']:
      role = metadata.roles.new()
      role.role = cast['castcrewTitleKo']
      role.actor = item['nameKo'] if item['nameKo'] else item['nameEn']
      metadata.roles.add(role)
  if cate == 'movie':
    metadata.directors.clear()
    metadata.writers.clear()
    for name in directors:
      metadata.directors.append(name)
    for name in writers:
      metadata.writers.append(name)

  # (3) from photo page
  url_tmpl = DAUM_TV_PHOTO if cate == 'tv' else DAUM_MOVIE_PHOTO
  data = JSON.ObjectFromURL(url=url_tmpl % metadata.id)
  max_poster = int(Prefs['max_num_posters'])
  max_art = int(Prefs['max_num_arts'])
  idx_poster = 0
  idx_art = 0
  for item in data['data']:
    if item['photoCategory'] == '1' and idx_poster < max_poster:
      art_url = item['fullname']
      if not art_url: continue
      #art_url = RE_PHOTO_SIZE.sub("/image/", art_url)
      art = HTTP.Request( item['thumbnail'] )
      idx_poster += 1
      metadata.posters[art_url] = Proxy.Preview(art, sort_order = idx_poster)
    elif item['photoCategory'] in ['2', '50'] and idx_art < max_art:
      art_url = item['fullname']
      if not art_url: continue
      #art_url = RE_PHOTO_SIZE.sub("/image/", art_url)
      art = HTTP.Request( item['thumbnail'] )
      idx_art += 1
      metadata.art[art_url] = Proxy.Preview(art, sort_order = idx_art)
  Log.Debug('Total %d posters, %d artworks' %(idx_poster, idx_art))
  if idx_poster == 0:
    if poster_url:
      poster = HTTP.Request( poster_url )
      metadata.posters[poster_url] = Proxy.Media(poster)
    else:
      url = 'http://m.movie.daum.net/m/tv/main?tvProgramId=%s' % metadata.id
      html = HTML.ElementFromURL( url )
      arts = html.xpath('//img[@class="thumb_program"]')
      for art in arts:
        art_url = art.attrib['src']
        if not art_url: continue
        art = HTTP.Request( art_url )
        idx_poster += 1
        metadata.posters[art_url] = Proxy.Preview(art, sort_order = idx_poster)

  if cate == 'tv':
    # (4) from episode page
    page = HTTP.Request(DAUM_TV_EPISODE % metadata.id).content
    match = Regex('MoreView\.init\(\d+, (.*), \$\(', Regex.DOTALL).search(page)
    if match:
      data = JSON.ObjectFromString(match.group(1))
      for item in data:
        episode_num = item['sequence']
        episode = metadata.seasons['1'].episodes[episode_num]
        episode.title = item['title']
        episode.summary = item['introduceDescription'].strip()
        if item['channels'][0]['broadcastDate']:
          episode.originally_available_at = Datetime.ParseDate(item['channels'][0]['broadcastDate'], '%Y%m%d').date()
        try: episode.rating = float(item['rate'])
        except: pass
        episode.directors.clear()
        episode.writers.clear()
        for name in directors:
          episode.directors.add(name)
        for name in writers:
          episode.writers.add(name)
        #episode.thumbs[thumb_url] = Proxy.Preview(thumb_data)

    # (5) fill missing info
    if Prefs['override_tv_id'] != 'None':
      page = HTTP.Request(DAUM_TV_DETAIL2 % metadata.id).content
      match = Regex('<em class="title_AKA"> *<span class="eng">([^<]*)</span>').search(page)
      if match:
        metadata.original_title = match.group(1).strip()

####################################################################################################
class DaumMovieAgent(Agent.Movies):
  name = "Daum Movie"
  languages = [Locale.Language.Korean]
  primary_provider = True
  accepts_from = ['com.plexapp.agents.localmedia']

  def search(self, results, media, lang, manual=False):
    return searchDaumMovie('movie', results, media, lang)

  def update(self, metadata, media, lang):
    Log.Info("in update ID = %s" % metadata.id)
    updateDaumMovie('movie', metadata)

    # override metadata ID
    if Prefs['override_movie_id'] != 'None':
      title = metadata.original_title if metadata.original_title else metadata.title
      if Prefs['override_movie_id'] == 'IMDB':
        url = IMDB_TITLE_SRCH % urllib.quote_plus("%s %d" % (title.encode('utf-8'), metadata.year))
        page = HTTP.Request( url ).content
        match = RE_IMDB_ID.search(page)
        if match:
          metadata.id = match.group(1)
          Log.Info("override with IMDB ID, %s" % metadata.id)

class DaumMovieTvAgent(Agent.TV_Shows):
  name = "Daum Movie"
  primary_provider = True
  languages = [Locale.Language.Korean]
  accepts_from = ['com.plexapp.agents.localmedia']

  def search(self, results, media, lang, manual=False):   
    return searchDaumMovie('tv', results, media, lang)

  def update(self, metadata, media, lang):
    Log.Info("in update ID = %s" % metadata.id)
    updateDaumMovie('tv', metadata)

    # override metadata ID
    if Prefs['override_tv_id'] != 'None':
      title = metadata.original_title if metadata.original_title else metadata.title
      if Prefs['override_tv_id'] == 'TVDB':
        url = TVDB_TITLE_SRCH % urllib.quote_plus(title.encode('utf-8'))
        xml = XML.ElementFromURL( url )
        node = xml.xpath('/Data/Series/seriesid')
        if node:
          metadata.id = node[0].text
          Log.Info("override with TVDB ID, %s" % metadata.id)
